#!/usr/bin/env bash

set -e
set -x

echo "Building for ${BUILD_TARGET}"

xvfb-run --auto-servernum --server-args='-screen 0 640x480x24' "$UNITY_EXECUTABLE" \
    -batchmode \
    -projectPath $PROJECT_PATH \
    -force-glcore \
    -quit \
    -buildTarget ${BUILD_TARGET} \
    -customBuildTarget ${BUILD_TARGET} \
    -customBuildName ${BUILD_NAME} \
    -customBuildPath ${BUILD_PATH} \
    -executeMethod Builder.build \
    -logFile ./out.txt

cat out.txt

UNITY_EXIT_CODE=$?

if [ ${UNITY_EXIT_CODE} -eq 0 ]; then
  echo "Run succeeded, no failures occurred";
elif [ ${UNITY_EXIT_CODE} -eq 2 ]; then
  echo "Run succeeded, some tests failed";
elif [ ${UNITY_EXIT_CODE} -eq 3 ]; then
  echo "Run failure (other failure)";
else
  echo "Unexpected exit code ${UNITY_EXIT_CODE}";
fi

ls -la "${BUILD_PATH}"
[ -n "$(ls -A "${BUILD_PATH}")" ] # fail job if build folder is empty
